diff --git a/Changelog b/Changelog
index 49a16da7ca..ea75ba139b 100644
--- a/Changelog
+++ b/Changelog
@@ -26,6 +26,7 @@ version <next>:
 - stream specifiers in fftools can now match by stream disposition
 - LCEVC enhancement data exporting in H.26x and MP4/ISOBMFF
 - LCEVC filter
+- farbfeld muxer and demuxer
 
 
 version 7.0:
diff --git a/configure b/configure
index d568739bf9..67b799d5d8 100755
--- a/configure
+++ b/configure
@@ -3644,6 +3644,7 @@ iamf_demuxer_select="iamfdec"
 iamf_muxer_select="iamfenc"
 image2_alias_pix_demuxer_select="image2_demuxer"
 image2_brender_pix_demuxer_select="image2_demuxer"
+image_farbfeld_muxer_select="image2_muxer"
 imf_demuxer_deps="libxml2"
 imf_demuxer_select="mxf_demuxer"
 ipod_muxer_select="mov_muxer"
diff --git a/doc/general_contents.texi b/doc/general_contents.texi
index 5f22ccd72b..1f9c48c95b 100644
--- a/doc/general_contents.texi
+++ b/doc/general_contents.texi
@@ -502,6 +502,8 @@ library:
 @item Electronic Arts Multimedia  @tab    @tab X
     @tab Used in various EA games; files have extensions like WVE and UV2.
 @item Ensoniq Paris Audio File  @tab   @tab X
+@item FF                        @tab X @tab X
+    @tab farbfeld uncompressed image
 @item FFM (FFserver live feed)  @tab X @tab X
 @item Flash (SWF)               @tab X @tab X
 @item Flash 9 (AVM2)            @tab X @tab X
@@ -799,6 +801,8 @@ following image formats are supported:
     @tab Digital Picture Exchange
 @item EXR          @tab   @tab X
     @tab OpenEXR
+@item FF           @tab X @tab X
+    @tab farbfeld uncompressed image
 @item FITS         @tab X @tab X
     @tab Flexible Image Transport System
 @item HDR          @tab X @tab X
diff --git a/libavformat/Makefile b/libavformat/Makefile
index 7ca68a7036..e2bf420916 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -284,6 +284,8 @@ OBJS-$(CONFIG_IMAGE_CRI_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_DDS_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_DPX_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_EXR_PIPE_DEMUXER)     += img2dec.o img2.o
+OBJS-$(CONFIG_IMAGE_FARBFELD_PIPE_DEMUXER)+= farbfelddec.o
+OBJS-$(CONFIG_IMAGE_FARBFELD_MUXER)       += farbfeldenc.o
 OBJS-$(CONFIG_IMAGE_GEM_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_GIF_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_HDR_PIPE_DEMUXER)     += img2dec.o img2.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 305fa46532..01a9ef92e5 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -531,12 +531,14 @@ extern const FFInputFormat  ff_xwma_demuxer;
 extern const FFInputFormat  ff_yop_demuxer;
 extern const FFInputFormat  ff_yuv4mpegpipe_demuxer;
 extern const FFOutputFormat ff_yuv4mpegpipe_muxer;
-/* image demuxers */
+/* image (de)muxers */
 extern const FFInputFormat  ff_image_bmp_pipe_demuxer;
 extern const FFInputFormat  ff_image_cri_pipe_demuxer;
 extern const FFInputFormat  ff_image_dds_pipe_demuxer;
 extern const FFInputFormat  ff_image_dpx_pipe_demuxer;
 extern const FFInputFormat  ff_image_exr_pipe_demuxer;
+extern const FFInputFormat  ff_image_farbfeld_pipe_demuxer;
+extern const FFOutputFormat ff_image_farbfeld_muxer;
 extern const FFInputFormat  ff_image_gem_pipe_demuxer;
 extern const FFInputFormat  ff_image_gif_pipe_demuxer;
 extern const FFInputFormat  ff_image_hdr_pipe_demuxer;
diff --git a/libavformat/farbfelddec.c b/libavformat/farbfelddec.c
new file mode 100644
index 0000000000..3dfad8ad91
--- /dev/null
+++ b/libavformat/farbfelddec.c
@@ -0,0 +1,136 @@
+/*
+ * Image format
+ * YUV4MPEG demuxer
+ *
+ * Modified by Marcus B Spencer to suit the farbfeld_pipe demuxer on 14 September 2024
+ *
+ * Copyright (c) 2000, 2001, 2002 Fabrice Bellard
+ * Copyright (c) 2001, 2002, 2003 Fabrice Bellard
+ * Copyright (c) 2004 Michael Niedermayer
+ * Copyright (c) 2024 Marcus B Spencer
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avformat.h"
+#include "avio.h"
+#include "demux.h"
+#include "internal.h"
+#include "libavutil/imgutils.h"
+#include "libavutil/opt.h"
+
+#define FARBFELD_MAGIC_LEN 8
+#define FARBFELD_HEADER_LEN (FARBFELD_MAGIC_LEN + 4 + 4)
+
+typedef struct FarbfeldDemuxContext {
+    const AVClass *class;
+    AVRational framerate;
+} FarbfeldDemuxContext;
+
+static int farbfeld_read_header(AVFormatContext *ctx)
+{
+    FarbfeldDemuxContext *priv = ctx->priv_data;
+    char magic[FARBFELD_MAGIC_LEN];
+    int width, height;
+    int packet_size;
+    AVStream *st;
+    int ret;
+
+    if ((ret = avio_read(ctx->pb, magic, FARBFELD_MAGIC_LEN)) < 0)
+        return ret;
+
+    if (memcmp(magic, "farbfeld", FARBFELD_MAGIC_LEN))
+        return AVERROR_INVALIDDATA;
+
+    if (!(st = avformat_new_stream(ctx, NULL)))
+        return AVERROR(ENOMEM);
+
+    st->codecpar->codec_type = AVMEDIA_TYPE_VIDEO;
+    st->codecpar->format     = AV_PIX_FMT_RGBA64BE;
+    st->codecpar->codec_id   = AV_CODEC_ID_RAWVIDEO;
+
+    width  = avio_rb32(ctx->pb);
+    height = avio_rb32(ctx->pb);
+
+    st->codecpar->width     = width;
+    st->codecpar->height    = height;
+    st->codecpar->framerate =
+    st->avg_frame_rate      =
+    st->r_frame_rate        = priv->framerate;
+
+    packet_size = av_image_get_buffer_size(st->codecpar->format, width, height, 1);
+    if (packet_size < 0)
+        return AVERROR_INVALIDDATA;
+
+    ctx->packet_size = FARBFELD_HEADER_LEN + packet_size;
+
+    // reset position for inital packet
+    if ((ret = avio_seek(ctx->pb, 0, SEEK_SET)) < 0)
+        return ret;
+
+    return 0;
+}
+
+static int farbfeld_read_packet(AVFormatContext *ctx, AVPacket *pkt)
+{
+    char magic[FARBFELD_MAGIC_LEN];
+    int ret;
+
+    if ((ret = avio_read(ctx->pb, magic, FARBFELD_MAGIC_LEN)) < 0)
+        return ret;
+
+    if (memcmp(magic, "farbfeld", FARBFELD_MAGIC_LEN))
+        return AVERROR_INVALIDDATA;
+
+    // width and height are assumed to be constant
+    avio_skip(ctx->pb, 8);
+
+    if ((ret = av_get_packet(ctx->pb, pkt,
+                                      ctx->packet_size -
+                                      FARBFELD_HEADER_LEN)) < 0)
+        return ret;
+
+    pkt->stream_index = 0;
+
+    return 0;
+}
+
+#define OFFSET(x) offsetof(FarbfeldDemuxContext, x)
+#define DEC AV_OPT_FLAG_DECODING_PARAM
+
+static const AVOption demuxoptions[] = {
+    { "framerate", "set the video framerate", OFFSET(framerate), AV_OPT_TYPE_VIDEO_RATE, {.str = "25"}, 0, INT_MAX, DEC },
+    { NULL },
+};
+
+static const AVClass farbfeld_demux_class = {
+    .class_name = "FarbfeldDemuxContext",
+    .item_name  = av_default_item_name,
+    .option     = demuxoptions,
+    .version    = LIBAVUTIL_VERSION_INT,
+};
+
+const FFInputFormat ff_image_farbfeld_pipe_demuxer = {
+    .p.name           = "farbfeld_pipe",
+    .p.long_name      = NULL_IF_CONFIG_SMALL("piped farbfeld uncompressed image sequence"),
+    .p.extensions     = "ff",
+    .p.flags          = AVFMT_NOTIMESTAMPS,
+    .p.priv_class     = &farbfeld_demux_class,
+    .priv_data_size   = sizeof(FarbfeldDemuxContext),
+    .read_header      = farbfeld_read_header,
+    .read_packet      = farbfeld_read_packet,
+};
diff --git a/libavformat/farbfeldenc.c b/libavformat/farbfeldenc.c
new file mode 100644
index 0000000000..daa1defaf3
--- /dev/null
+++ b/libavformat/farbfeldenc.c
@@ -0,0 +1,143 @@
+/*
+ * misc image utilities
+ * YUV4MPEG muxer
+ * Image format
+ *
+ * Modified by Marcus B Spencer to suit the farbfeld muxer on 14 September 2024
+ *
+ * Copyright (c) 2001, 2002, 2003 Fabrice Bellard
+ * Copyright (c) 2000, 2001, 2002 Fabrice Bellard
+ * Copyright (c) 2004 Michael Niedermayer
+ * Copyright (c) 2024 Marcus B Spencer
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avformat.h"
+#include "img2.h"
+#include "internal.h"
+#include "libavutil/avstring.h"
+#include "libavutil/frame.h"
+#include "libavutil/opt.h"
+#include "mux.h"
+
+typedef struct FarbfeldMuxContext {
+    const AVClass *class;
+    int start_number, img_number;
+    int update;
+} FarbfeldMuxContext;
+
+static int farbfeld_init(AVFormatContext *ctx)
+{
+    FarbfeldMuxContext *priv = ctx->priv_data;
+
+    if (ctx->streams[0]->codecpar->codec_id != AV_CODEC_ID_WRAPPED_AVFRAME &&
+        ctx->streams[0]->codecpar->codec_id != AV_CODEC_ID_RAWVIDEO) {
+        av_log(ctx, AV_LOG_ERROR, "Codec not supported.\n");
+        return AVERROR_INVALIDDATA;
+    }
+
+    if (ctx->streams[0]->codecpar->format != AV_PIX_FMT_RGBA64BE) {
+        av_log(ctx, AV_LOG_ERROR,
+            "farbfeld only supports the rgba64be pixel format. "
+            "Add '-pix_fmt rgba64be' to your output options to resolve "
+            "this error.\n"
+        );
+        return AVERROR_INVALIDDATA;
+    }
+
+    priv->img_number = priv->start_number;
+
+    return 0;
+}
+
+static int farbfeld_write_packet(AVFormatContext *ctx, AVPacket *pkt)
+{
+    AVStream *st = ctx->streams[pkt->stream_index];
+    int width = st->codecpar->width, height = st->codecpar->height;
+    FarbfeldMuxContext *priv = ctx->priv_data;
+    char filename[1024];
+    const uint8_t *src;
+    const AVFrame *p;
+    AVIOContext *pb;
+    int ret;
+
+    if (priv->update)
+        av_strlcpy(filename, ctx->url, sizeof filename);
+    else if ((ret = ff_img_get_frame_filename(ctx, filename, sizeof filename,
+                                              priv->start_number,
+                                              priv->img_number)) < 0)
+        return ret;
+
+    if ((ret = ctx->io_open(ctx, &pb, filename, AVIO_FLAG_WRITE, NULL)) < 0) {
+        av_log(ctx, AV_LOG_ERROR, "Could not open file : %s\n", filename);
+        return ret;
+    }
+
+    avio_write(pb, "farbfeld", 8);
+
+    avio_wb32(pb, width);
+    avio_wb32(pb, height);
+
+    if (st->codecpar->codec_id == AV_CODEC_ID_RAWVIDEO)
+        avio_write(pb, pkt->data, pkt->size);
+    else {
+        p   = (const AVFrame *)pkt->data;
+        src = p->data[0];
+
+        for (int i = 0; i < height; i++) {
+            avio_write(pb, src, width * 8); // 8 bytes per pixel
+            src += p->linesize[0];
+        }
+    }
+
+    priv->img_number++;
+
+    avio_flush(pb);
+
+    return ff_format_io_close(ctx, &pb);
+}
+
+#define OFFSET(x) offsetof(FarbfeldMuxContext, x)
+#define ENC AV_OPT_FLAG_ENCODING_PARAM
+static const AVOption muxoptions[] = {
+    { "update",       "continuously overwrite one file",  OFFSET(update),       AV_OPT_TYPE_BOOL,{ .i64 = 0 }, 0, 1,       ENC },
+    { "start_number", "set first number in the sequence", OFFSET(start_number), AV_OPT_TYPE_INT, { .i64 = 1 }, 0, INT_MAX, ENC },
+    { NULL },
+};
+
+static const AVClass farbfeld_mux_class = {
+    .class_name = "FarbfeldMuxContext",
+    .item_name  = av_default_item_name,
+    .option     = muxoptions,
+    .version    = LIBAVUTIL_VERSION_INT,
+};
+
+const FFOutputFormat ff_image_farbfeld_muxer = {
+    .p.name           = "farbfeld",
+    .p.long_name      = NULL_IF_CONFIG_SMALL("farbfeld uncompressed image"),
+    .p.extensions     = "ff",
+    .p.audio_codec    = AV_CODEC_ID_NONE,
+    .p.video_codec    = AV_CODEC_ID_WRAPPED_AVFRAME,
+    .p.subtitle_codec = AV_CODEC_ID_NONE,
+    .p.flags          = AVFMT_NOTIMESTAMPS | AVFMT_NOFILE,
+    .p.priv_class     = &farbfeld_mux_class,
+    .priv_data_size   = sizeof(FarbfeldMuxContext),
+    .init             = farbfeld_init,
+    .write_packet     = farbfeld_write_packet,
+    .flags_internal   = FF_OFMT_FLAG_MAX_ONE_OF_EACH,
+};
diff --git a/tests/Makefile b/tests/Makefile
index 9b70145015..5cfc117305 100644
--- a/tests/Makefile
+++ b/tests/Makefile
@@ -183,6 +183,7 @@ include $(SRC_PATH)/tests/fate/ffprobe.mak
 include $(SRC_PATH)/tests/fate/fifo-muxer.mak
 include $(SRC_PATH)/tests/fate/filter-audio.mak
 # Must be included after vcodec.mak
+include $(SRC_PATH)/tests/fate/farbfeld.mak
 include $(SRC_PATH)/tests/fate/filter-video.mak
 include $(SRC_PATH)/tests/fate/fits.mak
 include $(SRC_PATH)/tests/fate/flac.mak
diff --git a/tests/fate/farbfeld.mak b/tests/fate/farbfeld.mak
new file mode 100644
index 0000000000..b51503b7b2
--- /dev/null
+++ b/tests/fate/farbfeld.mak
@@ -0,0 +1,14 @@
+tests/data/farbfeld-lena.ff: TAG = GEN
+tests/data/farbfeld-lena.ff: ffmpeg$(PROGSSUF)$(EXESUF) | tests/data
+	$(M)$(TARGET_EXEC) $(TARGET_PATH)/$< -nostdin \
+        -i $(TARGET_SAMPLES)/lena.pnm -y -bitexact -pix_fmt rgba64be \
+        $(TARGET_PATH)/tests/data/farbfeld-lena.ff 2>/dev/null
+
+FATE_FARBFELD += fate-farbfeld-lena
+fate-farbfeld-lena: tests/data/farbfeld-lena.ff
+fate-farbfeld-lena: CMD = framecrc -i $(TARGET_PATH)/tests/data/farbfeld-lena.ff
+
+FATE_FARBFELD-$(call ALLYES, IMAGE_FARBFELD_PIPE_DEMUXER IMAGE_FARBFELD_MUXER) += $(FATE_FARBFELD)
+
+FATE_SAMPLES_FFMPEG += $(FATE_FARBFELD-yes)
+fate-farbfeld: $(FATE_FARBFELD-yes)
diff --git a/tests/ref/fate/farbfeld-lena b/tests/ref/fate/farbfeld-lena
new file mode 100644
index 0000000000..75fc52284a
--- /dev/null
+++ b/tests/ref/fate/farbfeld-lena
@@ -0,0 +1,6 @@
+#tb 0: 1/25
+#media_type 0: video
+#codec_id 0: rawvideo
+#dimensions 0: 256x256
+#sar 0: 0/1
+0,          0,          0,        1,   524288, 0x8c061893